
#ifndef RCREADER_H
#define RCREADER_H

/*
*****************************************************************************
*
*                          Copyright (c) 2000 2004
*
*  All rights reserved.
*
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions are met:
*
*  - Redistributions of source code must retain the above copyright notice, 
*     this list of conditions and the following disclaimer.
*  - Redistributions in binary form must reproduce the above copyright notice, 
*     this list of conditions and the following disclaimer in the documentation
*     and/or other materials provided with the distribution.
*  - The names of its contributors may not be used to endorse or promote 
*     products derived from this software without specific prior written 
*     permission.
*   
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
*  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
*  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
*  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE 
*  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
*  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
*  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
*  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
*  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
*  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
*  POSSIBILITY OF SUCH DAMAGE.
*
******************************************************************************
* File          : RcReader.h
* Author        : Zadig
* Creation date : 14/08/2004
*.............................................................................
* Modifications :
******************************************************************************
*/
#include <OS.h>
#include <Input.h>
#include <RcDefs.h>

class RcReader
{
   public:
      RcReader(uint16 i_Channel, uint16 i_ChannelNb);
      ~RcReader(void);
      void RcReader::SetChannelNb(uint16 i_ChannelNb);
      bool ChannelHasChanged(uint16 *i_Channel);
      int32 Thread(void);

   private:
      volatile bool  b_Quit;     //thead control flag
      thread_id      i_Thread;   //thread ID

      uint16         i_CurChannel;
      uint16         i_NbChannel;
      port_id        i_RcPort;
      BInputDevice   *pc_BercDevice;
};

#endif /* RCREADER_H */
