
#ifndef _STAMPRC_H_
#define _STAMPRC_H_

#include "VideoPlugin.h"
#include <Message.h>
#include <Path.h>
#include "RcReader.h"

class StampRcPluginType : public VideoPluginType
{
   public:
      StampRcPluginType(VideoPluginsHost * host, image_id id);
      virtual           ~StampRcPluginType();

      virtual const char*  ID();
      virtual uint32       Flags();
      virtual uint32       Version();
      virtual const char*  Name();
      virtual const char*  Author();
      virtual int32        GetVerticesProperties(const vertice_properties ** ap);
      virtual VideoPluginEngine * InstanciateVideoPluginEngine();
   private:
};

class StampRcEngine : public VideoPluginEngine
{
   public:
      StampRcEngine(VideoPluginType * plugin);
      virtual        ~StampRcEngine();
      friend class   StampRcPluginType;
      
      virtual status_t RestoreConfig(BMessage & config);
      virtual status_t StoreConfig(BMessage & config);
      virtual BView*   ConfigureView();

      void StampRcEngine::GetText(BString& text);
      void StampRcEngine::SetText(const char * text);

      // UseFormat will be called before ApplyEffect is first called and when the image format changes.
      // No need to monitor the BBitmap format.
      virtual status_t UseFormat(media_raw_video_format & format, int which_work_mode);
      virtual status_t ApplyEffect(BBitmap * frame_in, BBitmap * frame_out, int64 frame_count, bool skipped_frames);

   private:
      RcReader *pc_Reader;
      int32   i_CurChannel;
      BString  fText;
};

#endif // _STAMPRC_H_
